#define __KERNEL__


/* Saint Michael, Linux Kernel Module.
 * Verions: 0.02
 *
 * May 5, 2001
 *
 *
 *    Copyright (C) 2001  Timothy Lalwess (lawless@netdoor.com)
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of
 *    the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be
 *    useful, but WITHOUT ANY WARRANTY; without even the implied
 *    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *    PURPOSE.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *    USA.
 *      
 *
 * 
 */

 
#include <linux/sys.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/smp.h>
#include <linux/slab.h>
#include <asm/unistd.h>
#include <asm/current.h>
#include <sys/syscall.h>
#include <asm/errno.h>
#include "StMichael_lkm.h"

extern void * recorded_sys_call_table[];


int
sm_delete_module (const char *name)
{
   int delete_module_return;
   register int i;



   if ( ! sm_strncmp(name,"StMichael", 12) )
      {
         printk("(STMICHAEL) Attempt To Remove StMichael Detected.\n");
         return -EBUSY;
      }

   if ( ! sm_strncmp(name,"+",1) )
      {
        printk("STMICHAEL) Attempt to Remove Protected Module Detected.\n");
        return -EBUSY;
      }

   delete_module_return = (*orig_delete_module)(name);
   
  /* 
     Verify that the syscall table is the same. 
     If its changed then respond 

     We could probably make this a function in itself, but
     why spend the extra time making a call?

   */

   for (i = 0; i < NR_syscalls; i++)
       if ( recorded_sys_call_table[i] != sys_call_table[i] )
          {
            int j;

	    printk("(STMICHAEL) A Systemcall Table Change was detected on Moddelete. Possible Rootkit\n");
	    printk("(STMICHAEL) Module: %s\n",name);
            printk("(STMICHAEL) Returning SysCall Table to Pristine State.\n");

            for ( i = 0; i < NR_syscalls; i++)
                  sys_call_table[i] = recorded_sys_call_table[i];
        
            break;
            
          }   

  return delete_module_return;
}

